#include "vertex.h"
struct numero {
  /* Umi: Scitat, odcitat, porovnat, nasobit, delit a delit modulo.
	  Prevadet z long a do long i do jinych soustav.
	  Kopirovat, mazat, zjistit pocet mist, smazat prebytecne nuly.
	  Pridat na zacatek a na konec cisla, smazat cifru v levo.*/
  typedef unsigned char byte;
  typedef long buble;
  typedef unsigned long duble;
 private:
  char sign;
  int SystemSize;
  vertex cisla;
  byte *num;

 public:
  numero(void) {
    SystemSize = 256;
    sign = 1;
  }

  numero(int jaky) {
    if ((jaky > 1) && (jaky <= 256)) SystemSize = jaky;
    else SystemSize = 256;
    sign = 1;
  }

  char getsign(void) {
    return sign;
  }

  void setsign(char i) {
    if (i == 1) sign = 1;
    if (i == -1) sign = -1;
  }

  void chngsign(void) {
    sign *= -1;
  }

  int getsys(void) {
    return SystemSize;
  }

  void addl(byte a) {
    if (a < SystemSize) {
      num = (byte *)malloc(sizeof(byte));
      if (num == NULL) cisla.allocerr();
      (*num) = a;
      cisla.addf(num);
    }
  }

  void add(byte a) {
    if (a < SystemSize) {
      num = (byte *)malloc(sizeof(byte));
      if (num == NULL) cisla.allocerr();
      (*num) = a;
      cisla.addl(num);
    }
  }

  void dell(void) {
    cisla.delf();
  }

  void del(void) {
    cisla.dell();
  }

  void delall(void) {
    byte *numm;

    num = (byte *)cisla.getl();
    cisla.start();
    numm = (byte *)cisla.get();
    while (numm != num) {
      del();
      num = (byte *)cisla.getl();
    }
    del();
  }

  void plus(numero *i) {
    if (getsys() == (*i).getsys()) {
      buble a, b;
      byte ata, atb;
      byte *akta, *aktb;
      char overa, overb, ma, mb, sa, sb;

      overa = 0;
      overb = 0;
      ma = getsign();
      mb = (*i).getsign();
      sa = ma;
      sb = mb;
      if (sa == sb) {
	if (sa < 0) {
	  ma = -sa;
	  mb = -sb;
	}
      }

      if (sa != sb) {
	if ((sa > 0) && (sb < 0)) {
	  (*i).chngsign();
	  b = vetsi(i);
	  (*i).chngsign();
	  if (b == 1) {
	    ma = sa;
	    mb = sb;
	  }
	  if (b == -1) {
	    chngsign();
	    ma = -sa;
	    mb = -sb;
	  }
	}
	if ((sa < 0) && (sb > 0)) {
	  chngsign();
	  b = vetsi(i);
	  chngsign();
	  if (b == 1) {
	    ma = -sa;
	    mb = -sb;
	  }
	  if (b == -1) {
	    chngsign();
	    ma = sa;
	    mb = sb;
	  }
	}

      }

      b = 0;

      cisla.start();
      (*i).cisla.start();

      akta = (byte *)cisla.get();
      aktb = (byte *)(*i).cisla.get();
      ata = (*akta);
      atb = (*aktb);
      if (akta == NULL) {
	overa = 1;
	ata = 0;
      }
      if (aktb == NULL) {
	overb = 1;
	atb = 0;
      }

      while ((overa == 0) || (overb == 0)) {

	if (overa == 1) {
	  num = (byte *)malloc(sizeof(byte));
	  if (num == NULL) cisla.allocerr();
	  (*num) = 0;
	  cisla.addl(num);
	  akta = num;
	  ata = 0;
	}
	if (overb == 1) atb = 0;

	a = (buble)(ata)*ma + (buble)(atb)*mb + b;
	b = 0;
	if (a < 0) {
	  b = - 1;
	}
	if (a >= SystemSize) {
	  b = 1;
	}
	a -= SystemSize*b;
	(*akta) = (byte)a;

	if (overa != 1) {
	  akta = (byte *)cisla.get();
	  if (akta == NULL) overa = 1;
	}
	if (overb != 1) {
	  aktb = (byte *)(*i).cisla.get();
	  if (aktb == NULL) overb = 1;
	}
	ata = (*akta);
	atb = (*aktb);
      }

      if (b == 1) {
	num = (byte *)malloc(sizeof(byte));
	if (num == NULL) cisla.allocerr();
	(*num) = b;
	cisla.addl(num);
      }

      clean();
    }
  }

  void minus(numero *i) {
    (*i).chngsign();
    plus(i);
    (*i).chngsign();
  }

  void krat(numero *i) {
    if (getsys() == (*i).getsys()) {
      char sa, sb, overa, overb;
      duble a, b, k, l;
      byte *akta, *aktb, *aktc;
      numero mezi(getsys());

      sa = getsign();
      sb = (*i).getsign();

      k = 0;
      cisla.start();
      akta = (byte *)cisla.get();
      while (akta != NULL) {

	overa = 0;
	overb = 0;
	(*i).cisla.start();
	mezi.cisla.start();
	for (l = 0; l < k; l ++) {
	  mezi.cisla.move();
	}
	aktc = (byte *)mezi.cisla.get();
	if (aktc == NULL) overa = 1;
	aktb = (byte *)(*i).cisla.get();
	if (aktb == NULL) overb = 1;
	b = 0;
	while ((overa == 0) || (overb == 0)) {
	  if (overa == 1) {
	    num = (byte *)malloc(sizeof(byte));
	    if (num == NULL) mezi.cisla.allocerr();
	    (*num) = 0;
	    mezi.cisla.addl(num);
	    aktc = num;
	  }

	  if (overb == 1 ) a = (buble)(*aktc) + b;
	  else a = (buble)(*aktb)*(buble)(*akta) + (buble)(*aktc) + b;
	  b = 0;
	  if (a >= SystemSize) {
	    b = a/SystemSize;
	    a -= b*SystemSize;
	  }

	  (*aktc) = (byte)a;

	  if (overb == 0) {
	    aktb = (byte *)(*i).cisla.get();
	    if (aktb == NULL) overb = 1;
	  }
	  if (overa == 0) {
	    aktc = (byte *)mezi.cisla.get();
	    if (aktc == NULL) overa = 1;
	  }
	}
	if (b != 0) {
	  num = (byte *)malloc(sizeof(byte));
	  if (num == NULL) mezi.cisla.allocerr();
	  (*num) = b;
	  mezi.cisla.addl(num);
	}

	akta = (byte *)cisla.get();
	k ++;
      }

      copy(&mezi);
      setsign(sa*sb);
    }
  }

  void modulo(numero *i) {
    if (getsys() == (*i).getsys()) {
      numero j(getsys());
      buble k, m = 1;
      char savesgn = getsign();
      setsign(1);

      m = (*i).mist();   // kdyz i je 0 -deleni nulou- cislo se nezmeni.
      if (m == 1) {
	num = (byte *)(*i).cisla.getl();
	if ((*num) == 0) m = 0;
      }
      while (m > 0) {
	j.copy(i);
	j.setsign(1);
	m = mist() - (*i).mist();
	for (k = 1; k < m; k ++) {
	  j.addl(0);
	}
	while (getsign() > 0) {
	  minus(&j);
	}
	plus(&j);
      }

      setsign(savesgn);
    }
  }

  void deleno(numero *i) {
    if (getsys() == (*i).getsys()) {
      numero j(getsys()), d(getsys()), mm(getsys());
      buble k, m = 1;
      char savesgn = getsign()*(*i).getsign();
      setsign(1);

      m = (*i).mist();   // kdyz i je 0 -deleni nulou- cislo se nezmeni.
      if (m == 1) {
	num = (byte *)(*i).cisla.getl();
	if ((*num) == 0) m = 0;
      }
      while (m > 0) {
	j.copy(i);
	j.setsign(1);
	mm.insert(1);
	m = mist() - (*i).mist();
	for (k = 1; k < m; k ++) {
	  j.addl(0);
	  mm.addl(0);
	}
	while (getsign() > 0) {
	  minus(&j);
	  d.plus(&mm);
	}
	plus(&j);
	d.minus(&mm);
      }
      copy(&d);
      setsign(savesgn);
    }
  }

  buble mist(void) {
    buble i = 0;
    cisla.start();
    num = (byte *)cisla.get();
    while (num != NULL) {
      i++;
      num = (byte *)cisla.get();
    }
    return i;
  }

  void insert(long in) {
    buble hlp;
    int sys = getsys();
    delall();
    if (in > 0) {
      setsign(1);
    }
    if (in < 0) {
      setsign(-1);
      in = -in;
    }
    if (in == 0) {
      add(0);
    }
    while (in != 0) {
      hlp = in/sys;
      hlp = in - hlp*sys;
      add(hlp);
      in = in/sys;
    }
  }

  long resert() {
    long hlp = 0, i = 1;
    int sys = getsys();
    cisla.start();
    num = (byte *)cisla.get();
    while (num != NULL) {
      hlp += (buble)(*num)*i;
      num = (byte *)cisla.get();
      i *= sys;
    }
    hlp *= getsign();
    return hlp;
  }

  void copy(numero *i) {
    byte *akta, *aktb;
    char overa = 0, overb = 0;
    setsign((*i).getsign());
    SystemSize = (*i).getsys();

    cisla.start();
    (*i).cisla.start();
    akta = (byte *)cisla.get();
    aktb = (byte *)(*i).cisla.get();
    if (akta == NULL) overa = 1;
    if (aktb == NULL) overb = 1;
    while ((overa == 0) || (overb == 0)) {
      if (overa == 1) {
	  num = (byte *)malloc(sizeof(byte));
	  if (num == NULL) cisla.allocerr();
	  (*num) = 0;
	  cisla.addl(num);
	  akta = num;
      }
      if (overb == 1) (*akta) = 0;
      else (*akta) = (*aktb);
      if (overa != 1) {
	akta = (byte *)cisla.get();
	if (akta == NULL) overa = 1;
      }
      if (overb != 1) {
	aktb = (byte *)(*i).cisla.get();
	if (aktb == NULL) overb = 1;
      }
    }
    clean();
  }

  int vetsi(numero *i) {
    int willreturn = 2;
    if (getsys() == (*i).getsys()) {
      char sa, sb;
      sa = getsign();
      sb = (*i).getsign();
      if ((sa > 0)&&(sb < 0)) willreturn = 1;
      if ((sa < 0)&&(sb > 0)) willreturn = -1;
      if ( ((sa > 0)&&(sb > 0)) || ((sa < 0)&&(sb < 0)) ) {
	byte *akta, *aktb;
	char v, over;

	cisla.start();
	(*i).cisla.start();
	v = 0;
	over = 0;
	akta = (byte *)cisla.get();
	aktb = (byte *)(*i).cisla.get();
	while (over == 0) {
	  if ((*akta)*sa > (*aktb)*sb) v = 1;
	  if ((*akta)*sa < (*aktb)*sb) v = -1;
	  akta = (byte *)cisla.get();
	  aktb = (byte *)(*i).cisla.get();
	  if (akta == NULL) {
	    if (sa > 0) over = -1;
	    else over = 1;
	  }
	  if (aktb == NULL) {
	    if (sa > 0) over = 1;
	    else over = -1;
	  }
	  if ((akta == NULL) && (aktb == NULL)) over = 2;
	}
	if (over == 2) willreturn = v;
	else willreturn = over;
      }
    } else willreturn = 2;

    return willreturn;
  }

  void clean(void) {
    byte *numm;
    char over = 0;

    num = (byte *)cisla.getl();
    over = (*num);
    cisla.start();
    numm = (byte *)cisla.get();
    if (numm == num) {
      if (over == 0) setsign(1);
      over = 1;
    }
    while (over == 0) {
      del();
      num = (byte *)cisla.getl();
      over = (*num);
      if (numm == num) {
	if (over == 0) setsign(1);
	over = 1;
      }
    }
  }


  void vypis(int y) {
    int i = 0;
    cisla.start();
    num = (byte *)cisla.get();
    while (num != NULL) {
      gotoxy(65 - i, y);
      cprintf("%d", (*num));
      num = (byte *)cisla.get();
      i ++;
    }
    if (getsign() == -1) {
      gotoxy(65 - i, y);
      cprintf("-");
    }
  }

  void convert(int sys) {
    numero i(sys), j(sys), k(sys), savesys(sys);
    char savesign = getsign();
    savesys.insert(getsys());
    i.add(0);
    j.add(1);

    cisla.start();
    num = (byte *)cisla.get();
    while (num != NULL) {
      k.insert((*num));
      k.krat(&j);
      i.plus(&k);
      num = (byte *)cisla.get();
      j.krat(&savesys);
    }
    copy(&i);
    setsign(savesign);

  }

  unsigned char *out(void) {
    unsigned char *hlp;
    numero i;
    buble k, m;
    char isign;

    if (getsign() < 0) isign = 1;
    else isign = 0;

    i.copy(this);
    i.convert(10);

    hlp = (char *)malloc(sizeof(char)*(i.mist()+1+isign));
    if (hlp == NULL) cisla.allocerr();

    m = i.mist() + isign;
    hlp[m] = NULL;
    i.cisla.start();
    for(k = m-1; k >= isign; k --) {
      num = (byte *)i.cisla.get();
      hlp[k] = (*num) + 48;
    }

    if (isign) hlp[0] = '-';

    return(hlp);
  }



};
