
/*  Knihovna jednosmerneho nekruhoveho seznamu, priklad je v VERTEX.CPP*/
struct vertex {
  typedef void *otype;			// Typ, ktery bude pozit jako polozka seznamu
 private:
  struct order {				// Samotny seznam
	otype object;				// odkazuje na pamet, kde jsou ulozena samotna data
	order *next;                // a ukazuje na dalsi polozku
  };

  order *last, *first, *actual; // Posledni polozka seznamu, prvni polozka seznamu, aktualne pouzivana polozka

 public:
  void allocerr(void) {			// Co udelat, kdyz neni dostatek pameti
	printf("\nChyba: Nedostatek pamti :)\n");
	exit(1);
  }

  vertex(void) {				// Constructor nastavi jen hodnoty nealokuje
	first = NULL;
	last = NULL;
	actual = first;
  }

  ~vertex(void) {				// Destructor smaze nejen polozky, ale i data
	order *acthelp;
	actual = first;
	while(actual != NULL) {
	  acthelp = (*actual).next;
	  free((*actual).object);
	  free(actual);
	  actual = acthelp;
	}
	first = NULL;
	last = NULL;
	actual = first;
  }

  void addl(otype object) {		// Pridej na konec
	order *lasthelp;
	lasthelp = (order *)malloc(sizeof(order));
	if (lasthelp == NULL) allocerr();
	if (first == NULL) {
	  first = lasthelp;
	  last = lasthelp;
	  actual = first;
	  (*first).object = object;
	  (*first).next = NULL;
	}
	else {
	  (*last).next = lasthelp;
	  last = lasthelp;
	  (*lasthelp).object = object;
	  (*lasthelp).next = NULL;
	  if (actual == NULL) actual = lasthelp;
	}
  }

  void dell(void) {             // Smaz posledni polozku
	if (last != NULL) {
	  actual = first;
	  while(((*actual).next != last) && (actual != last))
		move();
	  free((*last).object);
	  free(last);
	  if (actual == last) {
		first = NULL;
		last = NULL;
		actual = first;
	  }
	  else {
		last = actual;
		(*actual).next = NULL;
	  }
	}
  }

  void addf(otype object) {     // Pridej na zacatek (pred prvni) polozku
	order *firsthelp;
	firsthelp = (order *)malloc(sizeof(order));
	if (firsthelp == NULL) allocerr();
	(*firsthelp).next = first;
	first = firsthelp;
	(*first).object = object;
	actual = first;
  }

  void delf(void) {				// Smaz prvni polozku
	if (first != NULL) {
	  order *firsthelp;
	  firsthelp = first;
	  first = (*first).next;
	  free((*firsthelp).object);
	  free(firsthelp);
	  actual = first;
	}
  }

  void add(otype object, void *bellow) {	// pridej polozku za tu na kterou se ukazuje pointerem bellow
	order *belord, *newbel;
	belord = (order *)bellow;
	newbel = (order *)malloc(sizeof(order));
	if (newbel == NULL) allocerr();
	(*newbel).next = (*belord).next;
	(*newbel).object = object;
	(*belord).next = newbel;
  }

  void del(void *delbel) {      // smaz polozku za tou na kterou ukazuje pointer delbel
	order *delord;
	delord = (order *) delbel;
	actual = (*delord).next;
	if (actual != NULL) {
	  (*delord).next = (*actual).next;
	  if ((*delord).next == NULL) last = delord;
	  free((*actual).object);
	  free(actual);
	  actual = last;
	}
  }

  void *getaddr(void) {         // Zjisti adresu aktualni polozky
	return(actual);
  }

  otype getl(void) {            // Zjisti obsah posledni polozky
	return((*last).object);
  }

  otype getf(void *getthis) {   // Zjisti obsah polozky na kterou se odkazuje pointerem getthis
	order *getord;
	getord = (order *)getthis;
	return((*getord).object);
  }


  void start(void) {			// Nastav aktualni polozku jako prvni
	actual = first;
  }

  void move(void) {				// Posun aktualni polozku v seznamu o jedenu dopredu
	if (actual != NULL) actual = (*actual).next;
  }

  otype get(void) {				// Zjisti obsah aktualni polozky a aktivuj dalsi polozku
	otype acthelp;
	acthelp = (*actual).object;
	move();
	return(acthelp);
  }

  otype geta(void) {				// Zjisti obsah aktualni polozky
	otype acthelp;
	acthelp = (*actual).object;
	return(acthelp);
  }

  void printest(void) {			// Test vsech polozek
	int i = 0;
	actual = first;
	while(actual != NULL) {
	  printf("prvek %d ma adresu %p \n", i, actual);
	  actual = (*actual).next;
	  i ++;
	}
  }

};
